unit hiPIPEClient;

interface

uses Kol,Share,Windows,Debug;

type
  THIPIPEClient = class(TDebug)
   private
    strm:PStream;
    th:PThread;
    Status:byte;
    lol:string;
    Comp: string;
    hf:cardinal;
    s: string;    
    function Execute(Sender:PThread): Integer;
    procedure SyncExec;
    
   public
    _prop_Name:string;
    _data_Name:THI_Event;
    _prop_Computer:string;
    _data_Stream:THI_Event;
    _data_Computer:THI_Event;
    _event_onStatus:THI_Event;

    destructor Destroy; override;
    procedure _work_doWrite(var _Data:TData; Index:word);
  end;

implementation

procedure THIPIPEClient._work_doWrite;
begin
   if Assigned(th) then exit;
   Strm := ReadStream(_Data,_data_Stream);
   if Strm = nil then exit;
   Comp := ReadString(_Data,_data_Computer,_prop_Computer);
   lol:= ReadString(_Data,_data_Name,_prop_Name);
   th := {$ifdef F_P}NewThreadforFPC{$else}NewThread{$endif};
   th.OnExecute := Execute;
   th.Resume;
   th.Tag := 1;
end;


function THIPIPEClient.Execute(Sender:PThread): Integer;
var   nBytesWrite:cardinal;
begin
   while not Sender.Terminated do begin
      Strm.Position := 0;
      SetLength(s, Strm.Size);
      if Strm.Size > 0 then Strm.Read(s[1],Strm.Size);
      hf := CreateFile(PChar('\\'+Comp+'\PIPE\' + lol),GENERIC_WRITE,
         FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      if hf <> INVALID_HANDLE_VALUE then begin
         Status := byte(WriteFile(hf,s[1],Strm.Size,nBytesWrite,nil))
      end else
         Status := 0;
      SetLength(s, 0);
      CloseHandle(hf);
      Sender.Synchronize(SyncExec);
   end;
   Result := 0;
end;

procedure THIPIPEClient.SyncExec;
begin
   _hi_OnEvent(_event_onStatus,Status);
   free_and_nil(th);
end;

destructor THIPIPEClient.Destroy;
begin
   if Assigned(th) then begin
      free_and_nil(th);
      CloseHandle(hf);
      SetLength(s, 0);
   end;   
   inherited Destroy;
end;

end.
